package com.zh.lingnuo.model;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.TableId;

import java.time.LocalDateTime;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 *
 * </p>
 *
 * @author zh
 * @since 2022-09-19
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
public class CompanyQnTitle extends Model {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 问卷id
     */
    private Integer qnId;

    /**
     * 题库题目id
     */
    private Integer titleId;

    /**
     * 题目
     */
    private String title;

    /**
     * 1=填空题 2=选择题 3=互选题
     */
    private Integer kind;

    /**
     * 1=个人 2=调研
     */
    private Integer groupId;

    /**
     * 标签
     */
    private String tag;

    /**
     * 选项
     */
    private String options;

    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedAt;

    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createdAt;

    /**  填空题 */
    public static int CompanyQnTitleKindFill = 1;
    /**  选择题 */
    public static int CompanyQnTitleKindChoice = 2;
    /**  互选题 */
    public static int CompanyQnTitleKindPartnerChoice = 3;
    /**  多选题 */
    public static int CompanyQnTitleKindMultiChoice = 4;

    /**  基础题目 */
    public static int ManageQnTitleBase = 1;
    /**  调研题目 */
    public static int ManageQnTitleNotBase = 2;

    /**  最大选项数 */
    public static int ManageQnTitleMaxOptions = 16;

    public static String getKindName(int kind) {
        switch (kind) {
            case 1:
                return "填空题";
            case 2:
                return "选择题";
            case 3:
                return "互选题";
            case 4:
                return "多选题";
            default:
                return "未知";
        }
    }
    public static String getGroupName(int groupId){
        switch (groupId){
            case 1:
                return "个人";
            case 2:
                return "调研";
            default:
                return "未知";
        }
    }
}
