package com.zh.lingnuo.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zh.lingnuo.controller.company.CompanyQnController;
import com.zh.lingnuo.controller.manage.ManageCompanyQnController;
import com.zh.lingnuo.model.Company;
import com.zh.lingnuo.model.CompanyQn;
import com.baomidou.mybatisplus.extension.service.IService;
import com.zh.lingnuo.utils.result.Result;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author zh
 * @since 2022-09-13
 */
public interface ICompanyQnService extends IService<CompanyQn> {

    // 管理端问卷列表
    Result<IPage<CompanyQn>> manageQnList(ManageCompanyQnController.paramsManageCompanyQnList params);

    // 列表
    Result<IPage<CompanyQn>> qnList(CompanyQnController.paramsQnList params);

    // 新增
    Result qnAdd(CompanyQnController.paramsQnAdd params);

    // 修改基础信息
    Result qnUpd(CompanyQnController.paramsQnUpd params);

    // 发布
    Result release(CompanyQn qn);

    // 全量发送邮件
    Result groupSendMail(int qnId, Company company);

    // 停止问卷
    Result end(int qnId);

    // 问卷结果
    Result result(int qnId);

    // 校验问卷所属企业
    String validCompany(int qnId, int companyId);
}
