package com.zh.lingnuo.serviceImpl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zh.lingnuo.controller.company.CompanyQnTitleController;
import com.zh.lingnuo.controller.company.CompanyQnTitleController.ResultQnTitleList;
import com.zh.lingnuo.model.CompanyQnTitle;
import com.zh.lingnuo.mapper.CompanyQnTitleMapper;
import com.zh.lingnuo.model.QnTitle;
import com.zh.lingnuo.service.ICompanyQnService;
import com.zh.lingnuo.service.ICompanyQnTitleService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zh.lingnuo.service.IQnTitleService;
import com.zh.lingnuo.utils.Common;
import com.zh.lingnuo.utils.FuncRes;
import com.zh.lingnuo.utils.PageUtil;
import com.zh.lingnuo.utils.result.Result;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author zh
 * @since 2022-09-19
 */
@Service
public class CompanyQnTitleServiceImpl extends ServiceImpl<CompanyQnTitleMapper, CompanyQnTitle> implements ICompanyQnTitleService {

    @Autowired
    private ICompanyQnService companyQnService;
    @Autowired
    private IQnTitleService qnTitleService;

    // 列表
    public Result<List<ResultQnTitleList>> qnTitleList(int qnId) {
        QueryWrapper<CompanyQnTitle> qw = new QueryWrapper<>();
        qw.eq("qn_id", qnId).orderByAsc("id");
        List<CompanyQnTitle> list = super.list(qw);
        List <ResultQnTitleList> result = new ArrayList<>();
        for (CompanyQnTitle r : list) {
            CompanyQnTitleController.ResultQnTitleList v = new CompanyQnTitleController.ResultQnTitleList();
            BeanUtils.copyProperties(r, v);
            v.setOptions(JSONObject.parseObject(r.getOptions()));
            v.setKindName(CompanyQnTitle.getKindName(r.getKind()));
            v.setGroupName(CompanyQnTitle.getGroupName(r.getGroupId()));
            result.add(v);
        }
//        IPage page = super.page(PageUtil.SetPage(params.getPageNum(), params.getPageSize()), qw);
//        page.convert(r -> {
//            CompanyQnTitleController.ResultQnTitleList v = new CompanyQnTitleController.ResultQnTitleList();
//            BeanUtils.copyProperties(r, v);
//            v.setOptions(JSONObject.parseObject((String) Common.ObjectFieldValue(r, "options")));
//            v.setKindName(CompanyQnTitle.getKindName((Integer) Common.ObjectFieldValue(r, "kind")));
//            v.setGroupName(CompanyQnTitle.getGroupName((Integer) Common.ObjectFieldValue(r, "groupId")));
//            return v;
//        });
        return Result.success(result);
    }

    // 新增
    public Result qnTitleAdd(CompanyQnTitleController.paramsQnTitleGroupAdd params) {
        ArrayList<CompanyQnTitle> list = new ArrayList<>();
        for(CompanyQnTitleController.paramsQnTitleAdd i:params.getTitleGroup()) {
            CompanyQnTitle companyQnTitle = new CompanyQnTitle()
                .setQnId(params.getQnId())
                .setTitle(i.getTitle())
                .setKind(i.getKind())
                .setGroupId(i.getGroupId());
            {
                String[] options = i.getOptions();
                if (Common.isContain(new int[]{CompanyQnTitle.CompanyQnTitleKindChoice, CompanyQnTitle.CompanyQnTitleKindPartnerChoice,CompanyQnTitle.CompanyQnTitleKindMultiChoice}, i.getKind())) {
                    FuncRes funcRes = QnTitle.optionsToObj(options);
                    if (!funcRes.isSuccess()) {
                        return Result.err(funcRes.getMsg());
                    }
                    companyQnTitle.setOptions((String) funcRes.getData());
                }
            }
            list.add(companyQnTitle);
        }
        if (!super.saveBatch(list)) {
            return Result.err("保存出错");
        }
        return Result.success("");
    }

    // 添入题库题目
    public Result qnTitleAddModel(CompanyQnTitleController.paramsQnTitleAddModel params) {
    Integer qnId = params.getQnId();
    // 已有题型id列表
        List<CompanyQnTitle> cList = super.list(new QueryWrapper<CompanyQnTitle>().select("title_id").eq("qn_id", qnId));
        HashSet<Integer> idList = new HashSet<>();
        ArrayList<CompanyQnTitle> list = new ArrayList<>();
        for (CompanyQnTitle i : cList) {
            idList.add(i.getTitleId());
        }
    // 待加入题型数组
        Collection ids = new ArrayList<>();
        HashMap<Integer, QnTitle> titleList = new HashMap();
        if (params.getTitleIds().length > 0) {
            for (int i : params.getTitleIds()) {
                ids.add(i);
            }
        }
        Collection<QnTitle> qnTitles = qnTitleService.listByIds(ids);
        for (QnTitle qnTitle : qnTitles) {
            titleList.put(qnTitle.getId(),qnTitle);
        }

        // 批量加入
        for (int titleId : params.getTitleIds()) {
            if(idList.contains(titleId)){
                continue;
            }
            if (null ==titleList.get(titleId)){
                continue;
            }
           QnTitle  i = titleList.get(titleId);
            CompanyQnTitle companyQnTitle = new CompanyQnTitle()
                .setQnId(params.getQnId())
                .setTitleId(i.getId())
                .setTitle(i.getTitle())
                .setKind(i.getKind())
                .setGroupId(i.getGroupId()==1?CompanyQnTitle.ManageQnTitleBase:CompanyQnTitle.ManageQnTitleNotBase)
                .setOptions(i.getOptions());
          list.add(companyQnTitle);
        }
        super.saveBatch(list);
        return Result.success("");
    }

    // 修改
    public Result qnTitleUpd(CompanyQnTitleController.paramsQnTitleUpd params) {
        CompanyQnTitle r = super.getById(params.getId());
        if (null == r) {
            return Result.err("未知题目");
        }
        String companyErr = companyQnService.validCompany(r.getQnId(), params.getUserInfo().getId());
        if (null != companyErr) {
            return Result.err(companyErr);
        }
        UpdateWrapper<CompanyQnTitle> up = new UpdateWrapper<CompanyQnTitle>()
            .eq("id", params.getId())
            .set(StringUtils.isNotBlank(params.getTitle()), "title", params.getTitle());
        {
            String[] options = params.getOptions();
            if (Common.isContain(new int[]{CompanyQnTitle.CompanyQnTitleKindChoice, CompanyQnTitle.CompanyQnTitleKindPartnerChoice,CompanyQnTitle.CompanyQnTitleKindMultiChoice}, r.getKind())) {
                FuncRes funcRes = QnTitle.optionsToObj(options);
                if (!funcRes.isSuccess()) {
                    return Result.err(funcRes.getMsg());
                }
                up.set("options", (String) funcRes.getData());
            }
        }
        if (!super.update(new CompanyQnTitle(), up)) {
            return Result.err("更新出错");
        }
        return Result.success("");
    }

    // 删除
    public Result qnTitleDel(CompanyQnTitleController.paramsQnTitleDel params) {
        CompanyQnTitle r = super.getById(params.getId());
        if (null == r) {
            return Result.err("未知题目");
        }
        String companyErr = companyQnService.validCompany(r.getQnId(), params.getUserInfo().getId());
        if (null != companyErr) {
            return Result.err(companyErr);
        }
        if (!super.removeById(params.getId())) {
            return Result.err("删除失败");
        }
        return Result.success("");
    }

}
