package com.zh.lingnuo.utils;

import org.apache.commons.lang3.StringUtils;
import org.springframework.util.DigestUtils;

import java.lang.reflect.Field;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Common {

    // 获取随机数
    public static String getRandomString(int length, String string) {

        String str = (string.length() > 0) ? string : "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        Random random = new Random();
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < length; i++) {
            sb.append(str.charAt(random.nextInt(str.length())));
        }
        return sb.toString();
    }

    //   验证是否是正确合法的手机号码
    public static Boolean telRegex(String tel) {
        if (tel.length() != 11) {
            return false;
        }
        Pattern pattern = Pattern.compile("^1[3,4,5,6,7,8,9]\\d{9}$");
        Matcher matcher = pattern.matcher(tel);
        if (matcher.matches()) {
            return true;
        }
        return false;
    }

    // md5
    public static String md5(String str) {
        return DigestUtils.md5DigestAsHex(str.getBytes(StandardCharsets.UTF_8));
    }

    // 是否大于0判断
    public static Boolean higherZero(Integer i) {
        if (null == i) {
            return false;
        }
        return i.compareTo(0) == 1 ? true : false;
    }

    // 获取obj元素值
    public static Object ObjectFieldValue(Object obj, String fieldName) {
        Class<?> resultClz = obj.getClass();
        Field[] fieldInfo = resultClz.getDeclaredFields();
        for (Field field : fieldInfo) {
            field.setAccessible(true); //成员变量为private,故必须进行此操
            if (field.getName() == fieldName) {
                try {
                    return field.get(obj);
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
        }
        return null;
    }

    // 修改obj元素
    public static Object changObjectValue(Object obj, String fieldName, Object value) {
        Class<?> resultClz = obj.getClass();
        Field[] fieldInfo = resultClz.getDeclaredFields(); //获取class里的所有字段  父类字段获取不到    注：如果出现加密解密失败 请先查看idno是否在父类中
        for (Field field : fieldInfo) {
            field.setAccessible(true); //成员变量为private,故必须进行此操
            if (field.getName() == fieldName) {
                try {
                    field.set(obj, value);
                } catch (IllegalAccessException e) {
                }
            }
        }
        return obj;
    }

    // obj转map
    public static Map<String, Object> objectToMap(Object obj) throws Exception {
        Map<String, Object> map = new HashMap<>();
        if (obj == null) {
            return null;
        }
        Field[] fields = obj.getClass().getDeclaredFields();//获取类的各个属性值
        for (Field field : fields) {
            String fieldName = field.getName();//获取类的属性名称
            String value = field.get(obj) != null ? field.get(obj).toString() : "";
            map.put(fieldName, value);
        }
        return map;
    }

    // arr是否包含int
    public static Boolean isContain(int[] arr, int v) {
        if (arr == null || arr.length == 0) {
            return false;
        }
        for (int i : arr) {
            if (i == v) {
                return true;
            }
        }
        return false;
    }

    // arr是否包含String
    public static Boolean isContain(String[] arr, String v) {
        if (arr == null || arr.length == 0) {
            return false;
        }
        for (String i : arr) {
            if (StringUtils.equals(i, v)) {
                return true;
            }
        }
        return false;
    }
}

