package com.zh.lingnuo.utils;

import com.zh.lingnuo.utils.result.HttpStatusEnum;
import lombok.Data;

@Data
public class FuncRes<T> {

    public FuncRes(boolean success, T data, String msg) {
        this.setSuccess(success);
        this.setData(data);
        this.setMsg(msg);
    }


    /**
     * 请求是否成功
     * true:成功
     * false：失败
     */
    private boolean success;

    /**
     * 状态码描述
     * 返回状态码对应的msg消息
     */
    private String msg;

    /**
     * 请求数据的结果
     */
    private T data;


    public static <T> FuncRes<T> success() {
        return new FuncRes<T>(true, null, "操作成功");
    }

    public static <T> FuncRes<T> success(String msg) {
        return new FuncRes<T>(true, null, msg);
    }

    public static <T> FuncRes<T> success(T data, String msg) {
        return new FuncRes<T>(true, data, msg);
    }


    public static <T> FuncRes<T> fail() {
        return new FuncRes<T>(false, null, "操作失败");
    }

    public static <T> FuncRes<T> fail(String msg) {
        return new FuncRes<T>(false, null, msg);
    }

    public static <T> FuncRes<T> fail(T data, String msg) {
        return new FuncRes<T>(false, data, msg);
    }

}
